package tech.nevets.igformatter;

import java.awt.*;
import java.awt.image.BufferedImage;

public class Images {
    private static final BufferedImage BACKGROUND = blankWhiteBackground();

    public static BufferedImage placeImageOnTop(BufferedImage fgImage) {
        BufferedImage image = BACKGROUND;
        Graphics2D imageG2D = image.createGraphics();

        int width = fgImage.getWidth();
        int height = fgImage.getHeight();
        int newWidth;
        int newHeight;
        int xPos;
        int yPos;

        if (width > height) {
            newWidth = 1048;
            newHeight = (newWidth * height) / width;
            xPos = 16;
            yPos = (1080 - newHeight) / 2;
        } else if (height > width) {
            newHeight = 1048;
            newWidth = (width * newHeight) / height;
            xPos = (1080 - newWidth) / 2;
            yPos = 16;
        } else {
            newWidth = 1048;
            newHeight = 1048;
            xPos = 16;
            yPos = 16;
        }

        imageG2D.drawImage(resizeImage(fgImage, newWidth, newHeight), xPos, yPos, newWidth, newHeight, null);
        imageG2D.dispose();

        return image;
    }

    private static BufferedImage resizeImage(BufferedImage rawImage, int width, int height) {
        BufferedImage resizedImage = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g = resizedImage.createGraphics();
        g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g.drawImage(rawImage, 0, 0, width, height, null);
        g.dispose();
        return resizedImage;
    }

    public static BufferedImage blankWhiteBackground() {
        BufferedImage image = new BufferedImage(1080, 1080, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2d = image.createGraphics();
        g2d.setColor(Color.WHITE);
        g2d.setPaint(Color.WHITE);
        g2d.fillRect(0, 0, 1080, 1080);
        g2d.dispose();
        return image;
    }
}
